传送门
文章目录
- 题意:
- 思路:
题意:
有两堆石子,两个人每次可以进行如下操作:从某一堆狮子中拿出x(x>0)x(x>0)x(x>0)个,从另一堆石子中拿出s∗x(s>=0)s*x(s>=0)s∗x(s>=0)个。谁不能操作谁输,问最终先手赢还是后手赢。
n,m≤3e5n,m\le3e5n,m≤3e5
思路:
假设两堆石子为(n,m)(n,m)(n,m),那么对于一个给定的nnn,一定最多只有一个mmm,(n,m)(n,m)(n,m)是先手必败态。这个比较显然吧,如果有两个,假设x,y,x<yx,y,x<yx,y,x<y,那么(n,y)(n,y)(n,y)的状态一定可以一步转移到(n,x)(n,x)(n,x)状态,这个时候(n,y)(n,y)(n,y)就是先手必胜了。
我们有了这个结论就可以直接暴力了,n2n^2n2枚举之后再枚举倍数,虽说是n2n^2n2,但是实际上只有最多nnn个点有意义,所以复杂度完全可以接受。
不知为何用bitsetbitsetbitset比用boolboolbool快一倍??
// Problem: Alice and Bob
// Contest: NowCoder
// URL: https://ac.nowcoder.com/acm/contest/11166/A
// Memory Limit: 524288 MB
// Time Limit: 2000 ms
//
// Powered by CP Editor (https://cpeditor.org)//#pragma GCC optimize("Ofast,no-stack-protector,unroll-loops,fast-math")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4.1,sse4.2,avx,avx2,popcnt,tune=native")
//#pragma GCC optimize(2)
#include<cstdio>
#include<iostream>
#include<string>
#include<cstring>
#include<map>
#include<cmath>
#include<cctype>
#include<vector>
#include<set>
#include<queue>
#include<algorithm>
#include<sstream>
#include<ctime>
#include<cstdlib>
#include<bitset>
#include<random>
#include<cassert>
#define X first
#define Y second
#define L (u<<1)
#define R (u<<1|1)
#define pb push_back
#define mk make_pair
#define Mid ((tr[u].l+tr[u].r)>>1)
#define Len(u) (tr[u].r-tr[u].l+1)
#define random(a,b) ((a)+rand()%((b)-(a)+1))
#define db puts("---")
using namespace std;//void rd_cre() { freopen("d://dp//data.txt","w",stdout); srand(time(NULL)); }
//void rd_ac() { freopen("d://dp//data.txt","r",stdin); freopen("d://dp//AC.txt","w",stdout); }
//void rd_wa() { freopen("d://dp//data.txt","r",stdin); freopen("d://dp//WA.txt","w",stdout); }typedef long long LL;
typedef unsigned long long ULL;
typedef pair<int,int> PII;const int N=5010,mod=1e9+7,INF=0x3f3f3f3f;
const double eps=1e-6;int n,m;
bitset<N>f[N];
//bool f[N][N];int main()
{
// ios::sync_with_stdio(false);
// cin.tie(0);for(int i=0;i<N;i++) {for(int j=0;j<N;j++) {if(!f[i][j]) {for(int k=1;k+i<N;k++) {for(int t=0;k*t+j<N;t++) {f[k+i][t*k+j]=1;}}for(int k=1;k+j<N;k++) {for(int t=0;k*t+i<N;t++) {f[t*k+i][k+j]=1;}}}}}int _; scanf("%d",&_);while(_--) {scanf("%d%d",&n,&m);if(f[n][m]) puts("Alice");else puts("Bob");}return 0;
}
/**/